﻿using System.Collections.Generic;
using System.Linq;

namespace Webhook_Catcher.Hub
{
    public class UserManager : IUserManager
    {
        public static List<HubClient> ConnectedClients { get; private set; } = new List<HubClient>();
        
        private static object _lock = new object();

        public void KeepUserConnection(HubClient clientModel)
        {
            lock (_lock)
            {
                ConnectedClients.Add(clientModel);
            }
        }

        public void RemoveUserConnection(string username)
        {
            lock (_lock)
            {
                var listOfClientsToRemove = ConnectedClients.Where(client => client.Username == username);
                foreach (var clientToRemove in listOfClientsToRemove.ToList())
                {
                    if (clientToRemove != null)
                    {
                        ConnectedClients.Remove(clientToRemove);
                    } 
                }
            }
        }

        public List<HubClient> GetConnectedClients() {
            return ConnectedClients;
        }
    }
}